package com.jsl.oa.utils;

import lombok.Getter;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Getter
public enum ErrorCode {
    WRONG_PASSWORD("WrongPassword", 40010, "密码错误"),
    PARAMETER_ERROR("ParameterError", 40011, "参数错误"),
    REQUEST_BODY_ERROR("RequestBodyError", 40012, "请求体错误"),
    USER_EXIST("UserExist", 40013, "用户名已存在"),
    TIMESTAMP_ERROR("TimestampError", 40014, "时间戳错误"),
    USER_NOT_EXIST("UserNotExist", 40015, "用户不存在"),
    USER_ROLE_NOT_EXIST("UserRoleNotExist", 40016, "用户权限不存在"),
    USER_ROLE_NOT_MANAGER("UserRoleNotExist", 40017, "用户权限非管理员权限"),
    UNAUTHORIZED("Unauthorized", 40100, "未授权"),
    TOKEN_EXPIRED("TokenExpired", 40101, "Token已过期"),
    VERIFICATION_INVALID("VerificationInvalid", 40102, "验证码无效"),
    TOKEN_NOT_EXIST("TokenNotExist", 40103, "Token不存在"),
    CLASS_COPY_EXCEPTION("ClassCopyException",40104,"实体类拷贝异常"),
    USER_IS_LOCKED("UserIsLocked", 40300, "用户已被锁定"),
    USER_IS_DEACTIVATED("UserIsDeactivated", 40301, "用户已被禁用"),
    NOT_ADMIN("NotAdmin", 40302, "不是管理员"),
    EMAIL_LOGIN_NOT_SUPPORT("EmailLoginNotSupport", 40303, "请使用邮箱登陆"),
    PASSWORD_NOT_SAME("PasswordNotSame", 40304, "两次密码不一致"),
    ID_NOT_EXIST("IdNotExist", 40400, "ID不存在"),
    ROLE_NOT_FOUNDED("RoleNotFounded", 40401, "角色不存在"),
    ROLE_NAME_REPEAT("RoleNameRepeat", 40402, "权限名称重复"),
    DATABASE_INSERT_ERROR("DatabaseInsertError", 50010, "数据库插入错误"),
    DATABASE_UPDATE_ERROR("DatabaseUpdateError", 50011, "数据库更新错误"),
    DATABASE_DELETE_ERROR("DatabaseDeleteError", 50012, "数据库删除错误"),
    PROJECT_NOT_EXIST("ProjectNotExist", 40016, "项目不存在");

    private final String output;
    private final Integer code;
    private final String message;

    ErrorCode(String output, Integer code, String message) {
        this.output = output;
        this.code = code;
        this.message = message;
    }
}
